exercise_05_22: exercise_05_22.o 
	g++     $^ -o $@
.gitignore:
	echo   exercise_05_22 > .gitignore  
%.ii: %.cpp
	g++ -E $^ -o $@
%.s: %.ii
	g++ -S $^ -o $@
%.o: %.s
	g++ -c $^ -o $@
clean:
	rm -f *.ii *.s *.o exercise_05_22 .gitignore test.out 
test: exercise_05_22
	@./exercise_05_22 < test.in > test.out && echo "test is executing..."
	@diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED
PRECIOUS: exercise_05_22.ii exercise_05_22.s
SECONDARY: exercise_05_22.ii exercise_05_22.s

dbg: debug/exercise_05_22
debug/%: debug/%.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@
debug/%.o: debug/%.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@
debug/%.s: debug/%.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@
debug/%.ii: %.cpp
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@
debug/%.ii: | debug
debug:
	mkdir -p debug
